VSphereFailureDomain [infrastructure.cluster.x-k8s.io/v1beta1]

Description
VSphereFailureDomain is the Schema for the vspherefailuredomains API.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

VSphereFailureDomainSpec defines the desired state of VSphereFailureDomain.

.spec

Description
VSphereFailureDomainSpec defines the desired state of VSphereFailureDomain.
Type
object
Required
regiontopologyzone
PropertyTypeDescription
regionobject

Region defines the name and type of a region

topologyobject

Topology describes a given failure domain using vSphere constructs

zoneobject

Zone defines the name and type of a zone

.spec.region

Description
Region defines the name and type of a region
Type
object
Required
nametagCategorytype
PropertyTypeDescription
autoConfigureboolean

AutoConfigure tags the Type which is specified in the Topology

Deprecated: This field is going to be removed in a future release.

namestring

Name is the name of the tag that represents this failure domain

tagCategorystring

TagCategory is the category used for the tag

typestring

Type is the type of failure domain, the current values are "Datacenter", "ComputeCluster" and "HostGroup"

.spec.topology

Description
Topology describes a given failure domain using vSphere constructs
Type
object
Required
datacenter
PropertyTypeDescription
computeClusterstring

ComputeCluster as the failure domain

datacenterstring

Datacenter as the failure domain.

datastorestring

Datastore is the name or inventory path of the datastore in which the virtual machine is created/located.

hostsobject

Hosts has information required for placement of machines on VSphere hosts.

networkConfigurationsarray

NetworkConfigurations is a list of network configurations within this failure domain.

networksarray

Networks is the list of networks within this failure domain

.spec.topology.hosts

Description
Hosts has information required for placement of machines on VSphere hosts.
Type
object
Required
hostGroupNamevmGroupName
PropertyTypeDescription
hostGroupNamestring

HostGroupName is the name of the Host group

vmGroupNamestring

VMGroupName is the name of the VM group

.spec.topology.networkConfigurations

Description
NetworkConfigurations is a list of network configurations within this failure domain.
Type
array

.spec.topology.networkConfigurations[]

Description
NetworkConfiguration defines a network configuration that should be used when consuming a failure domain.
Type
object
Required
networkName
PropertyTypeDescription
addressesFromPoolsarray

AddressesFromPools is a list of IPAddressPools that should be assigned to IPAddressClaims. The machine's cloud-init metadata will be populated with IPAddresses fulfilled by an IPAM provider.

dhcp4boolean

DHCP4 is a flag that indicates whether or not to use DHCP for IPv4.

dhcp4Overridesobject

DHCP4Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)

dhcp6boolean

DHCP6 is a flag that indicates whether or not to use DHCP for IPv6.

dhcp6Overridesobject

DHCP6Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)

nameserversarray

Nameservers is a list of IPv4 and/or IPv6 addresses used as DNS nameservers. Please note that Linux allows only three nameservers (https://linux.die.net/man/5/resolv.conf).

networkNamestring

NetworkName is the network name for this machine's VM.

searchDomainsarray

SearchDomains is a list of search domains used when resolving IP addresses with DNS.

.spec.topology.networkConfigurations[].addressesFromPools

Description
AddressesFromPools is a list of IPAddressPools that should be assigned to IPAddressClaims. The machine's cloud-init metadata will be populated with IPAddresses fulfilled by an IPAM provider.
Type
array

.spec.topology.networkConfigurations[].addressesFromPools[]

Description
TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.
Type
object
Required
kindname
PropertyTypeDescription
apiGroupstring

APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

kindstring

Kind is the type of resource being referenced

namestring

Name is the name of resource being referenced

.spec.topology.networkConfigurations[].dhcp4Overrides

Description
DHCP4Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)
Type
object
PropertyTypeDescription
hostnamestring

Hostname is the name which will be sent to the DHCP server instead of the machine's hostname.

routeMetricinteger

RouteMetric is used to prioritize routes for devices. A lower metric for an interface will have a higher priority.

sendHostnameboolean

SendHostname when true, the hostname of the machine will be sent to the DHCP server.

useDNSboolean

UseDNS when true, the DNS servers in the DHCP server will be used and take precedence.

useDomainsstring

UseDomains can take the values true, false, or route. When true, the domain name from the DHCP server will be used as the DNS search domain for this device. When route, the domain name from the DHCP response will be used for routing DNS only, not for searching.

useHostnameboolean

UseHostname when true, the hostname from the DHCP server will be set as the transient hostname of the machine.

useMTUboolean

UseMTU when true, the MTU from the DHCP server will be set as the MTU of the device.

useNTPboolean

UseNTP when true, the NTP servers from the DHCP server will be used by systemd-timesyncd and take precedence.

useRoutesstring

UseRoutes can take the values true, false, or route. When true, the routes from the DHCP server will be installed in the routing table.

.spec.topology.networkConfigurations[].dhcp6Overrides

Description
DHCP6Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)
Type
object
PropertyTypeDescription
hostnamestring

Hostname is the name which will be sent to the DHCP server instead of the machine's hostname.

routeMetricinteger

RouteMetric is used to prioritize routes for devices. A lower metric for an interface will have a higher priority.

sendHostnameboolean

SendHostname when true, the hostname of the machine will be sent to the DHCP server.

useDNSboolean

UseDNS when true, the DNS servers in the DHCP server will be used and take precedence.

useDomainsstring

UseDomains can take the values true, false, or route. When true, the domain name from the DHCP server will be used as the DNS search domain for this device. When route, the domain name from the DHCP response will be used for routing DNS only, not for searching.

useHostnameboolean

UseHostname when true, the hostname from the DHCP server will be set as the transient hostname of the machine.

useMTUboolean

UseMTU when true, the MTU from the DHCP server will be set as the MTU of the device.

useNTPboolean

UseNTP when true, the NTP servers from the DHCP server will be used by systemd-timesyncd and take precedence.

useRoutesstring

UseRoutes can take the values true, false, or route. When true, the routes from the DHCP server will be installed in the routing table.

.spec.topology.networkConfigurations[].nameservers

Description
Nameservers is a list of IPv4 and/or IPv6 addresses used as DNS nameservers. Please note that Linux allows only three nameservers (https://linux.die.net/man/5/resolv.conf).
Type
array

.spec.topology.networkConfigurations[].nameservers[]

Type
string

.spec.topology.networkConfigurations[].searchDomains

Description
SearchDomains is a list of search domains used when resolving IP addresses with DNS.
Type
array

.spec.topology.networkConfigurations[].searchDomains[]

Type
string

.spec.topology.networks

Description
Networks is the list of networks within this failure domain
Type
array

.spec.topology.networks[]

Type
string

.spec.zone

Description
Zone defines the name and type of a zone
Type
object
Required
nametagCategorytype
PropertyTypeDescription
autoConfigureboolean

AutoConfigure tags the Type which is specified in the Topology

Deprecated: This field is going to be removed in a future release.

namestring

Name is the name of the tag that represents this failure domain

tagCategorystring

TagCategory is the category used for the tag

typestring

Type is the type of failure domain, the current values are "Datacenter", "ComputeCluster" and "HostGroup"

API Endpoints

The following API endpoints are available:

  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/vspherefailuredomains
    • DELETE: delete collection of VSphereFailureDomain
    • GET: list objects of kind VSphereFailureDomain
    • POST: create a new VSphereFailureDomain
  • /apis/infrastructure.cluster.x-k8s.io/v1beta1/vspherefailuredomains/{name}
    • DELETE: delete the specified VSphereFailureDomain
    • GET: read the specified VSphereFailureDomain
    • PATCH: partially update the specified VSphereFailureDomain
    • PUT: replace the specified VSphereFailureDomain

/apis/infrastructure.cluster.x-k8s.io/v1beta1/vspherefailuredomains

HTTP method
DELETE
Description
delete collection of VSphereFailureDomain
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind VSphereFailureDomain
HTTP responses
HTTP codeResponse body
200 - OKVSphereFailureDomainList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new VSphereFailureDomain
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereFailureDomain schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereFailureDomain schema
201 - CreatedVSphereFailureDomain schema
202 - AcceptedVSphereFailureDomain schema
401 - UnauthorizedEmpty

/apis/infrastructure.cluster.x-k8s.io/v1beta1/vspherefailuredomains/{name}

HTTP method
DELETE
Description
delete the specified VSphereFailureDomain
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified VSphereFailureDomain
HTTP responses
HTTP codeResponse body
200 - OKVSphereFailureDomain schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified VSphereFailureDomain
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKVSphereFailureDomain schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified VSphereFailureDomain
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyVSphereFailureDomain schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKVSphereFailureDomain schema
201 - CreatedVSphereFailureDomain schema
401 - UnauthorizedEmpty